## javax.servlet
Interface RequestDispatcher

    public interface RequestDispatcher

Defines an object that receives requests from the client and sends them to any resource (such as a servlet, HTML file, or JSP file) on the server. The servlet container creates the `RequestDispatcher` object, which is used as a wrapper around a server resource located at a particular path or given by a particular name.

This interface is intended to wrap servlets, but a servlet container can create `RequestDispatcher` objects to wrap any type of resource.

Author:
  Various
See Also:
  `ServletContext.getRequestDispatcher(java.lang.String)`, `ServletContext.getNamedDispatcher(java.lang.String)`, `ServletRequest.getRequestDispatcher(java.lang.String)`

Field Summary
`static String` `ERROR_EXCEPTION` The name of the request attribute under which the exception object is propagated during an error dispatch
`static String` `ERROR_EXCEPTION_TYPE` The name of the request attribute under which the type of the exception object is propagated during an error dispatch
`static String` `ERROR_MESSAGE` The name of the request attribute under which the exception message is propagated during an error dispatch
`static String` `ERROR_REQUEST_URI` The name of the request attribute under which the request URI whose processing caused the error is propagated during an error dispatch
`static String` `ERROR_SERVLET_NAME` The name of the request attribute under which the name of the servlet in which the error occurred is propagated during an error dispatch
`static String` `ERROR_STATUS_CODE` The name of the request attribute under which the response status is propagated during an error dispatch
`static String` `FORWARD_CONTEXT_PATH` The name of the request attribute under which the original context path is made available to the target of a `forward`
`static String` `FORWARD_PATH_INFO` The name of the request attribute under which the original path info is made available to the target of a `forward`
`static String` `FORWARD_QUERY_STRING` The name of the request attribute under which the original query string is made available to the target of a `forward`
`static String` `FORWARD_REQUEST_URI` The name of the request attribute under which the original request URI is made available to the target of a `forward`
`static String` `FORWARD_SERVLET_PATH` The name of the request attribute under which the original servlet path is made available to the target of a `forward`
`static String` `INCLUDE_CONTEXT_PATH` The name of the request attribute under which the context path of the target of an `include` is stored
`static String` `INCLUDE_PATH_INFO` The name of the request attribute under which the path info of the target of an `include` is stored
`static String` `INCLUDE_QUERY_STRING` The name of the request attribute under which the query string of the target of an `include` is stored
`static String` `INCLUDE_REQUEST_URI` The name of the request attribute under which the request URI of the target of an `include` is stored
`static String` `INCLUDE_SERVLET_PATH` The name of the request attribute under which the servlet path of the target of an `include` is stored

Method Summary
`void` `forward(ServletRequest request, ServletResponse response)` Forwards a request from a servlet to another resource (servlet, JSP file, or HTML file) on the server.
`void` `include(ServletRequest request, ServletResponse response)` Includes the content of a resource (servlet, JSP page, HTML file) in the response.

Field Detail

### FORWARD_REQUEST_URI

    static final String FORWARD_REQUEST_URI

  The name of the request attribute under which the original request URI is made available to the target of a `forward`

  See Also:
    Constant Field Values

### FORWARD_CONTEXT_PATH

    static final String FORWARD_CONTEXT_PATH

  The name of the request attribute under which the original context path is made available to the target of a `forward`

  See Also:
    Constant Field Values

### FORWARD_PATH_INFO

    static final String FORWARD_PATH_INFO

  The name of the request attribute under which the original path info is made available to the target of a `forward`

  See Also:
    Constant Field Values

### FORWARD_SERVLET_PATH

    static final String FORWARD_SERVLET_PATH

  The name of the request attribute under which the original servlet path is made available to the target of a `forward`

  See Also:
    Constant Field Values

### FORWARD_QUERY_STRING

    static final String FORWARD_QUERY_STRING

  The name of the request attribute under which the original query string is made available to the target of a `forward`

  See Also:
    Constant Field Values

### INCLUDE_REQUEST_URI

    static final String INCLUDE_REQUEST_URI

  The name of the request attribute under which the request URI of the target of an `include` is stored

  See Also:
    Constant Field Values

### INCLUDE_CONTEXT_PATH

    static final String INCLUDE_CONTEXT_PATH

  The name of the request attribute under which the context path of the target of an `include` is stored

  See Also:
    Constant Field Values

### INCLUDE_PATH_INFO

    static final String INCLUDE_PATH_INFO

  The name of the request attribute under which the path info of the target of an `include` is stored

  See Also:
    Constant Field Values

### INCLUDE_SERVLET_PATH

    static final String INCLUDE_SERVLET_PATH

  The name of the request attribute under which the servlet path of the target of an `include` is stored

  See Also:
    Constant Field Values

### INCLUDE_QUERY_STRING

    static final String INCLUDE_QUERY_STRING

  The name of the request attribute under which the query string of the target of an `include` is stored

  See Also:
    Constant Field Values

### ERROR_EXCEPTION

    static final String ERROR_EXCEPTION

  The name of the request attribute under which the exception object is propagated during an error dispatch

  See Also:
    Constant Field Values

### ERROR_EXCEPTION_TYPE

    static final String ERROR_EXCEPTION_TYPE

  The name of the request attribute under which the type of the exception object is propagated during an error dispatch

  See Also:
    Constant Field Values

### ERROR_MESSAGE

    static final String ERROR_MESSAGE

  The name of the request attribute under which the exception message is propagated during an error dispatch

  See Also:
    Constant Field Values

### ERROR_REQUEST_URI

    static final String ERROR_REQUEST_URI

  The name of the request attribute under which the request URI whose processing caused the error is propagated during an error dispatch

  See Also:
    Constant Field Values

### ERROR_SERVLET_NAME

    static final String ERROR_SERVLET_NAME

  The name of the request attribute under which the name of the servlet in which the error occurred is propagated during an error dispatch

  See Also:
    Constant Field Values

### ERROR_STATUS_CODE

    static final String ERROR_STATUS_CODE

  The name of the request attribute under which the response status is propagated during an error dispatch

  See Also:
    Constant Field Values

Method Detail

### forward

    void forward(ServletRequest request,
                 ServletResponse response)
                 throws ServletException,
                        IOException

  Forwards a request from a servlet to another resource (servlet, JSP file, or HTML file) on the server. This method allows one servlet to do preliminary processing of a request and another resource to generate the response.

  For a `RequestDispatcher` obtained via `getRequestDispatcher()`, the `ServletRequest` object has its path elements and parameters adjusted to match the path of the target resource.

  `forward` should be called before the response has been committed to the client (before response body output has been flushed). If the response already has been committed, this method throws an `IllegalStateException`. Uncommitted output in the response buffer is automatically cleared before the forward.

  The request and response parameters must be either the same objects as were passed to the calling servlet's service method or be subclasses of the `ServletRequestWrapper` or `ServletResponseWrapper` classes that wrap them.

  This method sets the dispatcher type of the given request to `DispatcherType.FORWARD`.

  Parameters:
    `request` - a `ServletRequest` object that represents the request the client makes of the servlet
    `response` - a `ServletResponse` object that represents the response the servlet returns to the client
  Throws:
    `ServletException` - if the target resource throws this exception
    `IOException` - if the target resource throws this exception
    `IllegalStateException` - if the response was already committed
  See Also:
    `ServletRequest.getDispatcherType()`

### include

    void include(ServletRequest request,
                 ServletResponse response)
                 throws ServletException,
                        IOException

  Includes the content of a resource (servlet, JSP page, HTML file) in the response. In essence, this method enables programmatic server-side includes.

  The `ServletResponse` object has its path elements and parameters remain unchanged from the caller's. The included servlet cannot change the response status code or set headers; any attempt to make a change is ignored.

  The request and response parameters must be either the same objects as were passed to the calling servlet's service method or be subclasses of the `ServletRequestWrapper` or `ServletResponseWrapper` classes that wrap them.

  This method sets the dispatcher type of the given request to `DispatcherType.INCLUDE`.

  Parameters:
    `request` - a `ServletRequest` object that contains the client's request
    `response` - a `ServletResponse` object that contains the servlet's response
  Throws:
    `ServletException` - if the included resource throws this exception
    `IOException` - if the included resource throws this exception
  See Also:
    `ServletRequest.getDispatcherType()`

Copyright © 2012 GlassFish Community. All Rights Reserved.